<?php
/**************************************************
  Coppermine Plugin - Media RSS
  *************************************************
  Copyright (c) 2010 Marek Paterczyk
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
***************************************************/
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

header('Content-type: application/rss+xml');

$aid = $superCage->get->getInt('aid');
if  ($aid > 0)
{
	$query = "SELECT pid, title, caption, filepath, filename FROM ".$CONFIG['TABLE_PICTURES']." WHERE aid = $aid;";
}
else
{
	$query = "SELECT pid, title, caption, filepath, filename FROM ".$CONFIG['TABLE_PICTURES'].";";
}

$result = cpg_db_query($query);

$doc = new DomDocument('1.0');
$doc->standalone = true;
$doc->encoding = "utf-8";

$root = $doc->createElement('rss');
$root->setAttribute('version', '2.0');
$root->setAttribute('xmlns:media', 'http://search.yahoo.com/mrss/');
$root->setAttribute('xmlns:atom', "http://www.w3.org/2005/Atom");
$root = $doc->appendChild($root);

$channel = $root->appendChild($doc->createElement('channel'));

$desc = $channel->appendChild($doc->createElement('description'));
$desc->appendChild($doc->createTextNode("Album $aid"));

$link = $channel->appendChild($doc->createElement('link'));
$link->appendChild($doc->createTextNode($CONFIG['site_url']."thumbnails.php?album=$aid"));

$title = $channel->appendChild($doc->createElement('title'));
$title->appendChild($doc->createTextNode("Album $aid"));

$avi_regexp = "/.*\.avi$/i";
$jpg_regexp = "/.*\.jpe?g$/i";
$zip_regexp = "/.*\.zip$/i";
$mov_regexp= "/.*\.mov$/i";

while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
{
   $media_type = "unknown";
   if (preg_match($jpg_regexp, $row['filename']) == 1)
	$media_type = "image/jpeg";
   else if (preg_match($avi_regexp, $row['filename']) == 1)
	$media_type = "video/avi";
   else if (preg_match($zip_regexp, $row['filename']) == 1)
	$media_type = "application/zip";
   else if (preg_match($zip_regexp, $row['filename']) == 1)
	$media_type = "video/quicktime";
   if ($media_type == "unknown")
        continue;

   $item = $channel->appendChild($doc->createElement('item'));

   $title = $item->appendChild($doc->createElement('title'));
   $title->appendChild($doc->createTextNode($row['title']));

   $desc = $item->appendChild($doc->createElement('media:description'));
   $desc->appendChild($doc->createTextNode($row['caption']));

   $link = $item->appendChild($doc->createElement('link'));
   $link->appendChild($doc->createTextNode($CONFIG['site_url']."displayimage.php?albums=$aid&pid=".$row['pid']));

   $thumb = $item->appendChild($doc->createElement('media:thumbnail'));
   $thumb->setAttribute('url', $CONFIG['site_url'].'albums/'.$row['filepath']."thumb_".$row['filename']);

   $content = $item->appendChild($doc->createElement('media:content'));
   $content->setAttribute('url', $CONFIG['site_url'].'albums/'.$row['filepath'].$row['filename']);
   $content->setAttribute('type', $media_type);

   $guid = $item->appendChild($doc->createElement('guid'));
   $guid->appendChild($doc->createTextNode($CONFIG['site_url'].'albums/'.$row['filepath'].$row['filename']));
}

mysql_free_result($result);

$doc->formatOutput = true;
echo $doc->saveXML();

?>